; 
    include \masm32\include\masm32rt.inc
; 

IDC_EDIT equ 100
IDC_BTN  equ 101

; 

    .data
      hInstance dd 0
      hwndEdit  dd 0
      hFont     dd 0
      cf        CHOOSEFONT  <>
      lf        LOGFONT     <>
      N=128
      txt label byte
      REPEAT 126
        db N
        N=N+1
      ENDM
      db 0
    .code

; 

DlgProc proc hwndDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    SWITCH uMsg

      CASE WM_INITDIALOG

        mov cf.lStructSize, SIZEOF cf
        mov cf.lpLogFont, OFFSET lf
        mov cf.Flags, CF_SCREENFONTS

        invoke GetDlgItem, hwndDlg, IDC_EDIT
        mov hwndEdit, eax

        invoke SendMessage, hwndEdit, WM_SETTEXT, 0, ADDR txt

      CASE WM_COMMAND

        SWITCH wParam

          CASE IDC_BTN

            invoke ChooseFont, ADDR cf
            .IF eax
              invoke CreateFontIndirect, cf.lpLogFont
              mov hFont, eax
              invoke SendMessage, hwndEdit, WM_SETFONT, hFont, TRUE
            .ENDIF

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, 0

        ENDSW

      CASE WM_CLOSE

       invoke EndDialog, hwndDlg, 0

    ENDSW
    return 0

DlgProc endp

; 

start:

    invoke GetModuleHandle, NULL
    mov hInstance, eax

    Dialog "Test","MS Sans Serif",10, \
            WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, \
            2,0,0,200,150,1024
    DlgEdit WS_BORDER or ES_MULTILINE, \
            5,5,187,105,IDC_EDIT
    DlgButton "Select Font",WS_TABSTOP,70,120,45,10,IDC_BTN

    CallModalDialog hInstance,0,DlgProc,NULL

    exit

; 
end start
